#include <stdio.h>                  /* progX.C */
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <fstream>

#include "xAffichage.h"
#include "image.h"

#include "traitement.h"

int main(int argc, char** argv)
{
  Image I, Is;

  int nbRow, nbCol;

  XAffichage *Fi,*Fis;

  int  indSauvegardeI=1;
  int  indSauvegardeIs=1;
  char nomSauvegarde[2048];

  int  seuil=127,oldSeuil=-1;

  if (argc!=2) 
  {
   fprintf(stderr,"Usage : %s imageName\n",argv[0]);
   return 0;
  }

  loadImage(&I,argv[1]);

  seuillage(&I,&Is,seuil);

  nbRow=I.nbRow;
  nbCol=I.nbCol;

  Fi  = new XAffichage(nbRow,nbCol,0,0);
  Fis = new XAffichage(nbRow,nbCol,0,0);

  Fi->Afficher(&I);
  Fis->Afficher(&Is);

  printf("q: quitter\n");
  printf("s: sauver\n");
  printf("+|- : modif seuil\n");

  while (1)
    {
     char ci,cis;

     if (oldSeuil!=seuil) { seuillage(&I,&Is,seuil);
                            oldSeuil=seuil;
     }

     Fi->Afficher(&I);
     ci=Fi->XEvenement(&I);
     if (ci=='s' || ci=='S') {
       snprintf(nomSauvegarde,sizeof(nomSauvegarde),
                "../Resultats/ImageI%d.ras",indSauvegardeI);
       saveImage(&I,nomSauvegarde);
       indSauvegardeI++;
     }

     Fis->Afficher(&Is);
     cis=Fis->XEvenement(&Is);
     if (cis=='+') seuil = (seuil==255 ? 255 : seuil+1);
     if (cis=='-') seuil = (seuil==0 ? 0 : seuil-1);
     if (cis=='s' || cis=='S') {
       snprintf(nomSauvegarde,sizeof(nomSauvegarde),
                "../Resultats/ImageIs%d.ras",indSauvegardeIs);
       saveImage(&Is,nomSauvegarde);
       indSauvegardeIs++;
     }

     if (ci=='q' || ci=='Q' || cis=='q' || cis=='Q') break;
    }

 delete(Fi);
 delete(Fis);

 freeImage(&I);
 freeImage(&Is);

 return(0);
}
