#ifndef __XAFFICHAGE_H
#define __XAFFICHAGE_H


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <iostream>


#include "image.h"
#include <stdlib.h>

#define  NB  0
#define COUL 1

#define NBRE_COUL 256

#define BLANC 255
#define ROUGE 254
#define VERT  253
#define BLEU  252

using namespace std;

class XAffichage
{
 public:
  // Constructeur et destructeur

   XAffichage(int nbRow, int nbCol, int posX, int posY, int nature = NB);
  ~XAffichage();

  // Methode d'affichage

  void Afficher (const Image    *image);
  void Afficher (const ImageRVB *image, int coul=0);

  int XEvenement(const Image    *image); // Retour d'un int (-1 ou un char)
  int XEvenement(const ImageRVB *image, int coul=0); // idem

 private:
  // Attributs

  // Taille de l'image
  int _lignes;
  int _colonnes;

  // Coordonnees de la fenetre sur l'ecran
  int _posX;
  int _posY;

  // Nature de l'affichage NB ou COUL

  int _nature;
  
  // Parametres lies a Xlib
  Window _theWin, _theRoot;
  Display *_theDisplay;
  Visual *_theVisual;
  XImage *_image;
  int _theScreen;
  GC _theGC;
  unsigned long _bpx,_wpx;
  Colormap _theColormap;

  // Profondeur de l'ecran
  int _depth;

  // Et pour afficher une ImageRVB : Im24to8

  Image Im24to8;
};

#endif
